/***********************************************************************************/
/*                                                                                 */
/*                                 TRABAJO FIN DE GRADO                            */
/*                                   Control principal                              */
/*                                                                                 */
/***********************************************************************************/

#include <iostream>
#include "mosquittomqtt.h"

using namespace std;

float tempC_media; //Variable temperatura media
int tempMin;
int tempMax;
string str_tempC_media;
string str_tempMin;
string str_tempMax;

//Variables de la fecha
int dia=0;
int hora=6;
int mins=0;
int mins_old=0;
int seg=0;
int seg_old=0;

int intervalo = 0;//Intervalo del dia
int intervalo_old = 7; // Intervalo antiguo del dia

//Variables del totalizador de horas de funcionamiento
int estadisticas_horas_acumuladas = 0;
int estadisticas_mins_acumulados = 0;
bool estadisticas_permisivo_contador = 0;
string horometro;

//Variables del setpoint
int setpointTempC=15;
int setpointTempC_old=0;

//Variables de modo semi automatico
int modoSemiAUT = 0;
int modoSemiAUT_old = 0;

//Variable axuliar para actualizar el sp
int actualizar_SP = 1;

bool on = 0, off = 1; // para que solo accione la calefaccion una vez

string Dia_Hora;
string intervalo_str;


/*DECLARACIÓN DE LA ESTRUCTURA "TEMPERATURA"*/
struct Nodo
{
    int lectura;
    string timestamp;
    /*Sobrecargamos el operador '<' para que a la hora de comparar sepa que compara*/
    bool operator <(Nodo & n)
    {
        return lectura <  n.lectura;
    }
};

/************************************************************************************/
/* Nombre: void Insertar(list<T> &lista,  Nodo &temp)                               */
/* Descripción: Inserta un valor en la lista enlazada segun el criterio FIFO        */
/* Argumentos: Lista y temperatura nueva a insertar.                                */
/* Valor Devuelto: Ninguno                                                          */
/************************************************************************************/
template<typename T>
void Insertar(list<T> &lista,  Nodo &temp)
{
    if(lista.empty()) // Si lista esta vacia.
    {
         lista.emplace( lista.begin(), temp ); // Insertamos el primer valor.
    }
    else
    {
        lista.push_back(temp); // Insertamos un valor segun el criterio FIFO.
    }
} // Fin de la funcion Insertar().

/************************************************************************************/
/* Nombre: void Borrar(list<T> &lista)                                              */
/* Descripción: Borrar un valor de la lista enlazada segun el criterio FIFO.        */
/* Argumentos: Lista                                                                */
/* Valor Devuelto: Ninguno                                                          */
/************************************************************************************/
template<typename T>
void Borrar(list<T> &lista)
{
    if(lista.size()>=1) // Si el tamaño de la lista es mayor o igual a 1.
    {
        lista.pop_front(); // Borramos un valor segun el criterio FIFO.
    }
} //Fin de la funcion Borrar()

/************************************************************************************/
/* Nombre: void Imprimir(list<T> &lista)                                            */
/* Descripción: Imprime por pantalla los valores contenidos en la lista enlazada    */
/* Argumentos: Lista.                                                               */
/* Valor Devuelto: Ninguno                                                          */
/************************************************************************************/
template<typename T>
void Imprimir(list<T> &lista)
{
    typename list<T> ::iterator it; // Iterador que recorrerá la lista.
    int n=1; // Declaramos un contador "n" que nos indica la posicion en la que se encuentran
             //los valores en la cola.

    cout<<"\n\t             --------------------------------------------"<<endl;
    cout<<"\t            | LECTURA DE LOS DATOS CONTENIDOS EN LA COLA |"<<endl;
    cout<<"\t             --------------------------------------------\n"<<endl;

    if (lista.size()>0) // Si el tamaño de la lista es mayor que cero.
    {
        cout<<"\t\t ----------------------------------------------------"<<endl;
        cout<<"\t\t|  Núm  |Temperatura(ºC)|          Tiempo            |"<<endl;

        for(it=lista.begin(); it!=lista.end(); it++) // Con el iterador recorremos la lista y vamos imprimiento
        {                                            // los valores que va adquiriendo 'it'.

            cout<<"\t\t|-------|---------------|----------------------------|"<<endl;
            cout<<"\t\t|  -"<<n<<"-\t|      " << it->lectura;
            cout<< " \t| "<<it->timestamp ;//<< "|"<< endl;

            n++; // Incremeta en una unidad, a medida que se imprimen los datos.
        }

    cout<<"\t\t ----------------------------------------------------"<<endl;
    }
    else // Si la lista no contiene ningun valor.
    {
        cout<<"\n\t\t\t       ¡LISTA VACÍA!"<<endl;
    }
} // Fin de la funcion Imprimir().

/************************************************************************************/
/* Nombre: void MaxMin(list<T> &lista)                                              */
/* Descripción: Compara los valores de la lista enlazada y nos dice cual es máximo  */
/*              y mínimo.                                                           */
/* Argumentos: Lista.                                                               */
/*Valor Devuelto: Ninguno                                                           */
/************************************************************************************/
template<typename T>
void MaxMin(list<T> &lista,mosquittoMQTT* mqttHdl)
{

    typename list<T> :: iterator it; // Iterador que recorrera la lista.
    if(lista.size()==1) // Si el tamaño de la lista en igual a 1.
    {
        /*Se sabe que el maximo y el minimo son el mismo valor puesto que el
        tamaño de la lista es 1*/

        /*Con la llamada al algoritmo 'min_element' obtenemos el minimo valor
        contenido en la lista*/
        it = min_element(lista.begin(),lista.end());
        cout<<"\n\t\t       --------------------------------------------"<<endl;
        cout<<"\t\t      | LA TEMPERATURA MÁXIMA Y MÍNIMA SON IGUALES |"<<endl;
        cout<<"\t\t       --------------------------------------------\n"<<endl;

        cout<<"\t\t    --------------------------------------------"<<endl;
        cout<<"\t\t   |Temperatura(ºC)|           Tiempo           |"<<endl;
        cout<<"\t\t   |---------------|----------------------------|"<<endl;
        cout<<"\t\t   |    " << it->lectura << "\t   | ";
        cout<<it->timestamp ;//<< "|"<< endl;

        cout<<"\t\t    --------------------------------------------"<<endl;
        str_tempMax = to_string(it->lectura) + " ºC";
        str_tempMin = to_string(it->lectura) + " ºC";

    }
    else // Si la lista tiene un tamaño distinto de uno
    {
        /*Con la llamada al algoritmo 'max_element' obtenemos el mayor valor
        contenido en la lista*/
        it= max_element(lista.begin(),lista.end());

        cout<<"\n\t                  --------------------"<<endl;
        cout<<"\t                 | TEMPERATURA MÁXIMA |"<<endl;
        cout<<"\t                  --------------------\n"<<endl;

        cout<<"\t\t    --------------------------------------------"<<endl;
        cout<<"\t\t   |Temperatura(ºC)|           Tiempo           |"<<endl;
        cout<<"\t\t   |---------------|----------------------------|"<<endl;
        cout<<"\t\t   |    " << it->lectura << "\t   | ";
        cout<<it->timestamp ;//<< "|"<< endl;

        cout<<"\t\t    --------------------------------------------"<<endl;
        str_tempMax = to_string(it->lectura) + " ºC";

        /*Con la llamada al algoritmo 'min_element' obtenemos el minimo valor
        contenido en la lista*/
        it = min_element(lista.begin(),lista.end());

        cout<<"\n\t\t                  --------------------"<<endl;
        cout<<"\t\t                 | TEMPERATURA MÍNIMA |"<<endl;
        cout<<"\t\t                  --------------------\n"<<endl;

        cout<<"\t\t    --------------------------------------------"<<endl;
        cout<<"\t\t   |Temperatura(ºC)|           Tiempo           |"<<endl;
        cout<<"\t\t   |---------------|----------------------------|"<<endl;
        cout<<"\t\t   |    " << it->lectura << "\t   | ";
        cout<<it->timestamp ;//<< "|"<< endl;

        cout<<"\t\t    --------------------------------------------"<<endl;

        str_tempMin = to_string(it->lectura) + " ºC";

    }
    mqttHdl->publish(NULL, mqttHdl->topic_TempMax,str_tempMax.size(),str_tempMax.c_str(),0,true);
    mqttHdl->publish(NULL, mqttHdl->topic_TempMin,str_tempMin.size(),str_tempMin.c_str(),0,true);
} // Fin de la funcion MaxMin().

/************************************************************************************/
/* Nombre: void Tiempo()                                                            */
/* Descripción: Calcula la diferencia en segundos entre el año 2000 y la actualidad */
/* Argumentos: Ninguno.                                                             */
/* Valor Devuelto: Segundos.                                                        */
/************************************************************************************/
string Tiempo()
{
    int segundos; // Variable que almacena el tiempo.
    string fecha_hora;
    string dia_str;
    time_t timer; // Variable de la libreria ctime que nos indica el tiempo transcurrido desde 1970.
    segundos=time(&timer);
    fecha_hora = ctime (&timer);//Convertimos el tiempo en una string
    hora = atoi(fecha_hora.substr(11,2).c_str());
    mins = atoi(fecha_hora.substr(14,2).c_str());
    seg = segundos;
    dia_str = fecha_hora.substr(0,3);
    if(dia_str.compare("Mon")==0){
        dia = 0;
        dia_str = "Lun";
    }else if(dia_str.compare("Tue")==0){
        dia = 1;
        dia_str = "Mar";
    }else if(dia_str.compare("Wed")==0){
        dia = 2;
        dia_str = "Mie";
    }else if(dia_str.compare("Thu")==0){
        dia = 3;
        dia_str = "Jue";
    }else if(dia_str.compare("Fri")==0){
        dia = 4;
        dia_str = "Vie";
    }else if(dia_str.compare("Sat")==0){
        dia = 5;
        dia_str = "Sab";
    }else {
        dia = 6;
        dia_str = "Dom";
    }

    Dia_Hora = dia_str + " " + to_string(hora);
    if(mins<10){
        Dia_Hora = Dia_Hora + ":0" + to_string(mins);
    }else{
        Dia_Hora = Dia_Hora + ":" + to_string(mins);
    }

    return fecha_hora; // Devolvemos el valor de la variable segundos.
} // Fin de la funcion Tiempo().

/************************************************************************************/
/* Nombre: float media()                                                            */
/* Descripción: Calcula el valor medio de los datos contenidos en la lista          */
/* Argumentos: Lista.                                                               */
/* Valor Devuelto: Media                                                            */
/************************************************************************************/
template<typename T>
float media(list<T> &lista){

    typename list<T> :: iterator it; // Iterador que recorrera la lista.
    float sumatorio = 0;
    float media;
    int n = 0; // Contador tamaño de la lista

    if(lista.size()<10)
    {
        cout<<"\n\t\t                  --------------------"<<endl;
        cout<<"\t\t                 | TEMPERATURA  MEDIA |"<<endl;
        cout<<"\t\t                  --------------------\n"<<endl;

        cout<<"\n\t\t Valores insuficientes. \n\t\tMínimo 10 valores para calcular la media\n"<<endl;

    }
    else
    {
        for(it=lista.begin(); it!=lista.end(); it++)
        {
            sumatorio = it->lectura + sumatorio;
            n++;
        }

        media = sumatorio/n;

        cout<<"\n\t\t                  --------------------"<<endl;
        cout<<"\t\t                 | TEMPERATURA  MEDIA |"<<endl;
        cout<<"\t\t                  --------------------"<<endl;

        cout<<"\t\t                 |       "<<media<<"ºC      |"<<endl;
        cout<<"\t\t                  --------------------\n"<<endl;

    }
    return media;
}

/************************************************************************************/
/* Nombre: void horometro_caldera()                                                 */
/* Descripción: Calcula el tiempo que lleva funcionando la caldera                  */
/* Argumentos: llamada, actuador.                                                   */
/* Valor Devuelto: Ninguno                                                          */
/************************************************************************************/
void horometro_caldera(int llamada, bool actuador){
    if(llamada == 0){
        if(actuador == 0){
            estadisticas_permisivo_contador = 0;
        }else{
            estadisticas_permisivo_contador = 1;
        }
    }else{
        if(estadisticas_permisivo_contador == 1){
            estadisticas_mins_acumulados ++;
            if(estadisticas_mins_acumulados > 59){
                estadisticas_horas_acumuladas ++;
                estadisticas_mins_acumulados = 0;
            }
        }
    }
}//fin horometro_caldera()

/************************************************************************************/
/* Nombre: actuador()                                                               */
/* Descripción: enciende o apaga la salida del actuador en funcion de la temp       */
/* Argumentos: temp, setpoint, cliente mqtt                                         */
/* Valor Devuelto: nada                                                             */
/************************************************************************************/
void actuador(int temp, int setpoint, mosquittoMQTT* mqttHdl){
    //if(compara_mayor(temp,setpoint,1000) == 2 && on == 0)
    if(temp<=setpoint && on == 0)
    {
        cout<<"\n\t\t **Se ENCIENDE la calefacción\n"<<endl;
        mqttHdl->publish(NULL, mqttHdl->topic_ConsignaOnOff, 1,"1",0,true);
        on = 1;
        off = 0;
        horometro_caldera(0,1);
    }
    //if(compara_mayor(temp,setpoint,1000) == 1 && off == 0)
    if(temp > setpoint && off==0)
    {
        cout<<"\n\t\t **Se APAGA la calefacción\n"<<endl;
        mqttHdl->publish(NULL, mqttHdl->topic_ConsignaOnOff,1,"0",0,true);
        on = 0;
        off = 1;
        horometro_caldera(0,0);
    }
}

int intervalo_actual(int intervalos_hora[], int intervalos_mins[]){
    int posicion;

    for(int i=0; i<6; i++){
        if(intervalos_hora[i]==hora){
            if(intervalos_mins[i]<=mins){
                posicion = i;
                break;
            }else if(i==0 && intervalos_mins[i]>mins){
                posicion = 5;
                break;
            }else{
                posicion = i-1;
                break;
            }
        }else if(intervalos_hora[i]<hora){
            if(i!=5 && intervalos_hora[i+1]>hora){
                posicion = i;
                break;
            }else if(i==5){
                posicion = 5;
                break;
            }
        }else if(i==0 && intervalos_hora[i]>hora){
            posicion = 5;
            break;
        }
    }

    return posicion;
}

/*PROGRAMA PRINCIPAL, MAIN*/
int main()
{
    /*DECLARACIÓN DE VARIABLES*/
    list<Nodo> lista; // Lista de temperaturas.
    Nodo valor; // Variable de tipo nodo para almacenar los valores introducidos por el usuario.
    Nodo temp_max; //Cariable de tipo nodo para temperatura maxima
    Nodo temp_min; //Variable de tipo nodo para temperatura minima
    tempC_media=0.00;

    mosquittoMQTT * mqttHdl;
    mqttHdl = new mosquittoMQTT(NULL, "localhost", 1883);

    setlocale(LC_CTYPE, "Spanish"); // Reconoce los caracteres de la ortografia del castellano.

    /*Imprime los valores de tipo float con una precision decimal de 2.*/
    cout.setf(ios::fixed, ios::floatfield);
    cout.precision(2);

    /*FIN DECLARACIÓN DE VARIABLES*/

    while(1)
    {
        //Mantiene la conexion
        int res = mqttHdl->loop();
        if (res){
            mqttHdl->reconnect();
        }
        Tiempo();

        if(mins!=mins_old){
            mqttHdl->publish(NULL, mqttHdl->topic_DiaHora,Dia_Hora.size(),Dia_Hora.c_str(),0,true);
            horometro_caldera(1,0);
            if(estadisticas_horas_acumuladas < 10){
                horometro = "0" + to_string(estadisticas_horas_acumuladas) + " horas y ";
            }else{
                horometro = to_string(estadisticas_horas_acumuladas) + " horas y ";
            }
            if(estadisticas_mins_acumulados < 10){
                horometro = horometro + "0" + to_string(estadisticas_mins_acumulados) + " minutos";
            }else{
                horometro = horometro +  to_string(estadisticas_mins_acumulados) + " minutos";
            }
            mqttHdl->publish(NULL, mqttHdl->topic_Horometro,horometro.size(),horometro.c_str(),0,true);

            if(mqttHdl->tempC<=setpointTempC)
            {
                mqttHdl->publish(NULL, mqttHdl->topic_ConsignaOnOff, 1,"1",0,true);

            }
            if(mqttHdl->tempC > setpointTempC)
            {
                mqttHdl->publish(NULL, mqttHdl->topic_ConsignaOnOff,1,"0",0,true);
            }

            mins_old = mins;
        }

        //Calcula la temperatura media cuando recibe un dato nuevo
        if(mqttHdl->permit_tempC == 1)
        {
            //temperatura_media(mqttHdl->tempC);
            cout<<"\n\t             -----------------------------------"<<endl;
            cout<<"\t            | INTRODUCIR NUEVO VALOR EN LA COLA |"<<endl;
            cout<<"\t             -----------------------------------\n"<<endl;
            cout<<"\t"<<endl;

            valor.lectura = mqttHdl->tempC;
            valor.timestamp=Tiempo(); // El tiempo se le asigna automaticamente en el instante que ha sido
                                      // introducido la lectura.

            if(lista.size()<100) // Si la lista tiene menos de 10 valores.
            {
                Insertar(lista,valor); // Insertamos un valor segun el criterio FIFO.
            }
            else // Si la lista tiene 10 o mas valores.
            {
                /*Introducimos y sacamos un  valor segun el criterio FIFO.*/
                Insertar(lista, valor);
                Borrar(lista);
            }

            Imprimir(lista);

            cout<<"\t\t Setpoint: " << setpointTempC << endl;
            cout<<"\t\t Permiso Setpoint: " << mqttHdl->permit_setpoint << endl;
            cout<<"\t\t Intervalo: " << intervalo << endl;
            cout<<"\t\t Intervalo old: " << intervalo_old << endl;
            cout<<"\t\t Setpoint almacenado en el array diario: " << mqttHdl->Intervalos_calendario_DiarioTemp[intervalo] << endl;
            cout<<"\t\t Setpoint almacenado en el array festivo: " << mqttHdl->Intervalos_calendario_FestivoTemp[intervalo] << endl;
            cout<<"\t\t Setpoint old: " << setpointTempC_old << endl;
            cout<<"\t\t Dia: " << dia << endl;
            cout<<"\t\t Hora: " << hora << endl;
            cout<<"\t\t Minutos: " << mins << endl;
            cout<<"\t\t Modo trabajo: " << mqttHdl->modoTrabajo << endl;
            cout<<"\t\t Modo dia: " << mqttHdl->ModosDias_calendario[dia] <<endl;


            if(lista.size()>=5) // Si la lista contiene algun valor.
            {
                MaxMin(lista, mqttHdl);

                tempC_media=media(lista);

                str_tempC_media = to_string((int)tempC_media) + " ºC";
                mqttHdl->publish(NULL, mqttHdl->topic_TempMedia,str_tempC_media.size(),str_tempC_media.c_str(),0,true);
            }
            else // Si la lista esta vacia.
            {
                cout<<"\n\t\t                 -----------------------------"<<endl;
                cout<<"\t\t                | NO HAY VALORES QUE COMPARAR |"<<endl;
                cout<<"\t\t                 -----------------------------\n"<<endl;
                str_tempC_media = "-- ºC";
                mqttHdl->publish(NULL, mqttHdl->topic_TempMedia,str_tempC_media.size(),str_tempC_media.c_str(),0,true);
                str_tempMax = "--  ºC";
                mqttHdl->publish(NULL, mqttHdl->topic_TempMax,str_tempMax.size(),str_tempMax.c_str(),0,true);
                str_tempMin = "-- ºC";
                mqttHdl->publish(NULL, mqttHdl->topic_TempMin,str_tempMin.size(),str_tempMin.c_str(),0,true);
            }

            mqttHdl->permit_tempC = 0;
        }

        if(lista.size()>=5)
        {
            if(mqttHdl->estacionAno<1){

                if(mqttHdl->modoTrabajo<1){

                    if(mqttHdl->ModosDias_calendario[dia]<1){//Diario
                        intervalo = intervalo_actual(mqttHdl->Intervalos_calendario_DiarioHora, mqttHdl->Intervalos_calendario_DiarioMins);
                        if(mqttHdl->permit_setpoint==1){
                            setpointTempC = mqttHdl->setpoint_tempC_MAN;

                            if(setpointTempC > mqttHdl->Intervalos_calendario_DiarioTemp[intervalo]){
                                modoSemiAUT = 1;
                            }else if(setpointTempC < mqttHdl->Intervalos_calendario_DiarioTemp[intervalo]){
                                modoSemiAUT = 2;
                            }

                            if(setpointTempC==mqttHdl->Intervalos_calendario_DiarioTemp[intervalo] || intervalo_old!=intervalo){
                                modoSemiAUT = 0;
                                mqttHdl->permit_setpoint = 0;
                                actualizar_SP = 1;
                            }

                            if(modoSemiAUT!=modoSemiAUT_old){
                                mqttHdl->publish(NULL, mqttHdl->topic_modoSemiAUT,to_string(modoSemiAUT).size(),to_string(modoSemiAUT).c_str());
                                modoSemiAUT_old=modoSemiAUT;
                            }
                        }else{
                            setpointTempC = mqttHdl->Intervalos_calendario_DiarioTemp[intervalo];
                            if(actualizar_SP == 1 || intervalo_old!=intervalo || setpointTempC_old!=setpointTempC){
                                mqttHdl->publish(NULL, mqttHdl->topic_setpoint,to_string(setpointTempC).size(),to_string(setpointTempC).c_str());
                                actualizar_SP = 0;
                                setpointTempC_old = setpointTempC;

                                if(intervalo!=intervalo_old){
                                    intervalo_str = "D: " + to_string(intervalo+1);
                                    mqttHdl->publish(NULL, mqttHdl->topic_Intervalo,intervalo_str.size(),intervalo_str.c_str());
                                    intervalo_old = intervalo;
                                }
                            }
                        }

                    }else{//Festivo
                        intervalo = intervalo_actual(mqttHdl->Intervalos_calendario_FestivoHora, mqttHdl->Intervalos_calendario_FestivoMins);
                        if(mqttHdl->permit_setpoint==1){
                            setpointTempC = mqttHdl->setpoint_tempC_MAN;

                            if(setpointTempC > mqttHdl->Intervalos_calendario_FestivoTemp[intervalo]){
                                modoSemiAUT = 1;
                            }else if(setpointTempC < mqttHdl->Intervalos_calendario_FestivoTemp[intervalo]){
                                modoSemiAUT = 2;
                            }

                            if(setpointTempC==mqttHdl->Intervalos_calendario_FestivoTemp[intervalo] || intervalo_old!=intervalo){
                                modoSemiAUT = 0;
                                mqttHdl->permit_setpoint = 0;
                                actualizar_SP = 1;
                            }

                            if(modoSemiAUT!=modoSemiAUT_old){
                                mqttHdl->publish(NULL, mqttHdl->topic_modoSemiAUT,to_string(modoSemiAUT).size(),to_string(modoSemiAUT).c_str());
                                modoSemiAUT_old=modoSemiAUT;
                            }

                        }else{
                            setpointTempC = mqttHdl->Intervalos_calendario_FestivoTemp[intervalo];
                            if(actualizar_SP == 1 || intervalo_old!=intervalo || setpointTempC_old!=setpointTempC){
                                mqttHdl->publish(NULL, mqttHdl->topic_setpoint,to_string(setpointTempC).size(),to_string(setpointTempC).c_str());
                                actualizar_SP = 0;
                                setpointTempC_old = setpointTempC;

                                if(intervalo!=intervalo_old){
                                    intervalo_str = "F: " + to_string(intervalo+1);
                                    mqttHdl->publish(NULL, mqttHdl->topic_Intervalo,intervalo_str.size(),intervalo_str.c_str());
                                    intervalo_old = intervalo;
                                }
                            }
                        }
                    }

                }else{
                    if(mqttHdl->permit_setpoint==1){
                        setpointTempC = mqttHdl->setpoint_tempC_MAN;
                    }
                }
            }else{
                setpointTempC = -1;
                setpointTempC_old = setpointTempC;
                if(mqttHdl->permit_estacionAno == 1){
                    mqttHdl->publish(NULL, mqttHdl->topic_setpoint,1,"0");
                    mqttHdl->permit_estacionAno = 0;
                }
            }

            actuador(mqttHdl->tempC,setpointTempC, mqttHdl);
        }

    }
    return 0;
}
