#include "mosquittomqtt.h"

mosquittoMQTT::mosquittoMQTT(const char *id, const char *host, int port):mosquittopp(id)
{
    //Constructor
    mosqpp::lib_init(); //Se inicializa libmosquitto

	int keepalive = 120;
	connect(host, port, keepalive);		//Conectar con el broker MQTT
}

mosquittoMQTT::~mosquittoMQTT()
{
    //Destructor
    loop_stop(); //Se destruye el thread
    mosqpp::lib_cleanup();
}

//Metodo que se llama cuando se ha establecido la conexion con el broker
void mosquittoMQTT::on_connect(int rc)
{
	std::cout<<"Conectado con el codigo: "<< rc<<".\n"<< std::endl;
    std::cout<<"____________________________\n"<< std::endl;
	if (rc == 0)
	{
	    //Suscripcion de los topic
        subscribe(NULL, topic_ConexionAPP);
		subscribe(NULL, topic_tempActual);
		subscribe(NULL, topic_setpoint_MAN);
		subscribe(NULL, topic_estacionAno);
		subscribe(NULL, topic_modoTrabajo);
		subscribe(NULL, topic_modoCasa);
		subscribe(NULL, topic_temEcoMode);
		subscribe(NULL, topic_modoVacaciones);
		subscribe(NULL, topic_ModosDias);
		subscribe(NULL, topic_Intervalos);

	}
}

//Metodo que se llama cuando se recibe un mensaje de los topics a los que se esta suscrito
void mosquittoMQTT::on_message(const struct mosquitto_message *message)
{
    std::cout<<"\nRecibido: \n"<<"\t Topic: " << message->topic << "\n\t Mensaje: "<< (char *) message->payload << "\n"<< std::endl;

    std::string t(message->topic);
    std::string p = std::string((char *)message->payload);

    if(strcmp(t.c_str(),topic_ConexionAPP) == 0){

    }else if(strcmp(t.c_str(),topic_tempActual) == 0){
        tempC = std::atoi (p.c_str());
        permit_tempC = 1;
    }else if(strcmp(t.c_str(),topic_setpoint_MAN) == 0){
        setpoint_tempC_MAN = std::atoi (p.c_str());
        permit_setpoint = 1;
    }else if(strcmp(t.c_str(), topic_ModosDias)==0){
        p=p.substr(3);
        for(int i=0; i<7; i++){
            ModosDias_calendario[i] = std::atoi(p.substr(i+i,1).c_str());
        }
    }else if(strcmp(t.c_str(),topic_Intervalos)==0){
        int d = p.find("D-");
        int f = p.find("F-");
        int t = 0;
        int h = 3;
        int m = 6;
        std::string diario = p.substr(d+2,54);
        std::string festivo = p.substr(f+2,54);
        for(int i=0; i<6;i++){
            Intervalos_calendario_DiarioTemp[i] = std::atoi(diario.substr(i+t,2).c_str());
            Intervalos_calendario_DiarioHora[i] = std::atoi(diario.substr(i+h,2).c_str());
            Intervalos_calendario_DiarioMins[i] = std::atoi(diario.substr(i+m,2).c_str());
            Intervalos_calendario_FestivoTemp[i] = std::atoi(festivo.substr(i+t,2).c_str());
            Intervalos_calendario_FestivoHora[i] = std::atoi(festivo.substr(i+h,2).c_str());
            Intervalos_calendario_FestivoMins[i] = std::atoi(festivo.substr(i+m,2).c_str());
            t = t + 8;
            h = h + 8;
            m = m + 8;
        }
    }else if(strcmp(t.c_str(), topic_estacionAno)==0){
        estacionAno = std::atoi(p.c_str());
        if(estacionAno == 1){
            permit_estacionAno = 1;
        }
    }else if(strcmp(t.c_str(), topic_modoTrabajo)==0){
        modoTrabajo = std::atoi(p.c_str());
    }else if(strcmp(t.c_str(), topic_modoCasa)==0){
        modoCasa = std::atoi(p.c_str());
    }else if(strcmp(t.c_str(), topic_modoVacaciones)==0){
        modoVacaciones = std::atoi(p.c_str());
    }else if(strcmp(t.c_str(), topic_temEcoMode)==0){
    }

}
