#ifndef MOSQUITTOMQTT_H
#define MOSQUITTOMQTT_H

#include <mosquittopp.h>

#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <cstring>
#include <list>
#include <time.h>
#include <locale.h>
#include <algorithm>

class mosquittoMQTT : public mosqpp::mosquittopp
{
    public:

        int tempC; //Variable de la temperatura
        int setpoint_tempC_MAN; //Variable del setpoint en manual

        //Variables auxiliares
        bool permit_tempC;
        bool permit_setpoint;
        bool permit_estacionAno;

        int ModosDias_calendario [7]; //Variable modo de los dias de la semana (Diario o Festivo)

        //Variables de los intervalos de diario y festivo:
        int Intervalos_calendario_DiarioTemp [6];
        int Intervalos_calendario_DiarioHora [6];
        int Intervalos_calendario_DiarioMins [6];
        int Intervalos_calendario_FestivoTemp [6];
        int Intervalos_calendario_FestivoHora [6];
        int Intervalos_calendario_FestivoMins [6];

        //Variables de los modos de funcionamiento:
        int estacionAno;
        int modoTrabajo;
        int modoCasa;
        int modoVacaciones;
        int tempEcoMode;

        //Topics
        const char* topic_tempActual = "SENSOR/Temperatura";
        const char* topic_ConsignaOnOff = "ACTUADOR/Consigna_OnOff";
        const char* topic_actuadorEstado = "ACTUADOR/Estado";
        const char* topic_MaxEnviarActuador = "ACTUADOR/Max_enviar";
        const char* topic_ConexionAPP = "CONTROL_PPAL/Conexion_APP";
        const char* topic_setpoint = "CONTROL_PPAL/SetpointTemp";
        const char* topic_setpoint_MAN = "CONTROL_PPAL/Home/SetpointMAN";
        const char* topic_modoSemiAUT = "CONTROL_PPAL/Home/ModoSemiAUT";
        const char* topic_DiaHora = "CONTROL_PPAL/Home/Dia_Hora";
        const char* topic_Intervalo = "CONTROL_PPAL/Home/Intervalo";
        const char* topic_ModosDias = "CONTROL_PPAL/Calendario/Modo_dias";
        const char* topic_Intervalos = "CONTROL_PPAL/Calendario/Intervalos";
        const char* topic_Horometro = "CONTROL_PPAL/Estadisticas/Horometro";
        const char* topic_TempMin = "CONTROL_PPAL/Estadisticas/TempMin";
        const char* topic_TempMax = "CONTROL_PPAL/Estadisticas/TempMax";
        const char* topic_TempMedia = "CONTROL_PPAL/Estadisticas/TempMedia";
        const char* topic_estacionAno = "CONTROL_PPAL/Ajustes/Estacion_Ano";
        const char* topic_modoTrabajo = "CONTROL_PPAL/Ajustes/Modo_Trabajo";
        const char* topic_modoCasa = "CONTROL_PPAL/Ajustes/Modo_Casa";
        const char* topic_temEcoMode = "CONTROL_PPAL/Ajustes/Temp_EcoMode";
        const char* topic_modoVacaciones = "CONTROL_PPAL/Ajustes/Modo_Vacaciones";

        //Constructor y destructor de la clase
        mosquittoMQTT(const char *id, const char *host, int port);
        ~mosquittoMQTT();

        //Definicion de los metodos MQTT
        void on_connect(int rc);
        void on_message(const struct mosquitto_message *message);
};

#endif // MOSQUITTOMQTT_H
